Imports UJ.ExceptionManagement
Imports UJ.ExceptionManagement.Processing 
Module Module1
  
      ' Notes
      ' Try this application in Debug and Release builds. 
      ' In Debug build EMS dumps the entire exception report to console output.
      ' In Release build EMS shows only short message to user; the message is customizable (see below)

    Sub Main()
      'EMS Setup ---------------------------------------------------------------------------
      ' this is a must call; hooks to domain's UnhandledException event
#IF DEBUG 
      InitHelper.InitializeForConsoleApplication(True) 
#ELSE
      InitHelper.InitializeForConsoleApplication(False) 
      '-- Add file publisher to save exception report
      Ems.Settings.ReportPublishers.Add(new ReportPublisherFile("Errors.txt"))
#EndIf
      '-- You can change user message for the Release build
      Ems.Settings.UserMessageCaption = "My console app failed - sorry!" ' - to change the "caption"
      Ems.Settings.UserMessageTemplate = "Details: {0}"     ' - to change the detailed user message
      'END EMS setup ---------------------------------------------------------------------------

        Console.WriteLine("Welcome to EMS console demo!")
        Console.WriteLine("Run this demo in Debug and Release mode to how EMS shows the error in each case.")
      Do 
        Console.WriteLine("Enter integer number, or empty string to exit.")
        Console.WriteLine("Enter non-number string to cause fatal exception.")
        Console.Write("Enter value: ")
        Dim s as String = Console.ReadLine()
        Console.WriteLine() 
        if s = "" Then exit sub
        Dim i as Integer = Convert.ToInt32(s)  'Here it can blow up
        Console.WriteLine("You entered " & i.ToString())
      Loop While true
    End Sub

End Module
